CREATE NODE TABLE Company(CompanyId INT64, PRIMARY KEY (CompanyId));
CREATE NODE TABLE University(UniversityId INT64, PRIMARY KEY (UniversityId));
CREATE NODE TABLE Continent(ContinentId INT64, PRIMARY KEY (ContinentId));
CREATE NODE TABLE Country(CountryId INT64, PRIMARY KEY (CountryId));
CREATE NODE TABLE City(CityId INT64, PRIMARY KEY (CityId));
CREATE NODE TABLE Tag(TagId INT64, PRIMARY KEY (TagId));
CREATE NODE TABLE TagClass(TagClassId INT64, PRIMARY KEY (TagClassId));
CREATE NODE TABLE Forum(ForumId INT64, PRIMARY KEY (ForumId));
create NODE TABLE Comment (id int64, PRIMARY KEY (id));
create NODE TABLE Post (id int64, PRIMARY KEY (id));
CREATE NODE TABLE Person(PersonId INT64, PRIMARY KEY (PersonId));
CREATE REL TABLE City_isPartOf_Country(FROM City TO Country);
CREATE REL TABLE Comment_hasCreator_Person (FROM Comment TO Person, MANY_ONE);
CREATE REL TABLE Comment_hasTag_Tag (FROM Comment TO Tag, MANY_MANY);
CREATE REL TABLE Comment_isLocatedIn_Country (FROM Comment TO Country, MANY_ONE);
CREATE REL TABLE Comment_replyOf_Comment (FROM Comment TO Comment, MANY_ONE);
CREATE REL TABLE Comment_replyOf_Post (FROM Comment TO Post);
CREATE REL TABLE Company_isLocatedIn_Country(FROM Company TO Country);
CREATE REL TABLE Country_isPartOf_Continent(FROM Country TO Continent);
CREATE REL TABLE Forum_containerOf_Post (FROM Forum TO Post);
CREATE REL TABLE Forum_hasMember_Person(FROM Forum TO Person);
CREATE REL TABLE Forum_hasModerator_Person(FROM Forum TO Person);
CREATE REL TABLE Forum_hasTag_Tag(FROM Forum TO Tag);
CREATE REL TABLE Person_hasInterest_Tag(FROM Person TO Tag);
CREATE REL TABLE Person_isLocatedIn_City(FROM Person TO City);
CREATE REL TABLE Person_knows_Person(FROM Person TO Person);
CREATE REL TABLE Person_likes_Comment (FROM Person TO Comment);
CREATE REL TABLE Person_likes_Post (FROM Person TO Post);
CREATE REL TABLE Person_studyAt_University(FROM Person TO University);
CREATE REL TABLE Person_workAt_Company(FROM Person TO Company);
CREATE REL TABLE Post_hasCreator_Person (FROM Post TO Person, MANY_ONE);
CREATE REL TABLE Post_hasTag_Tag (FROM Post TO Tag, MANY_MANY);
CREATE REL TABLE Post_isLocatedIn_Country (FROM Post TO Country, MANY_ONE);
CREATE REL TABLE TagClass_isSubclassOf_TagClass(FROM TagClass TO TagClass);
CREATE REL TABLE Tag_hasType_TagClass(FROM Tag TO TagClass);
CREATE REL TABLE University_isLocatedIn_City(FROM University TO City);
